<?php
/*
Plugin Name: Facebook Tab Manager
Plugin URI: http://www.carrcommunications.com/wordpress-plugins/facebook-tab-manager/
Description: Makes WordPress function as an editor for tabs you can embed in a Facebook page for your business, campaign, or organization. Include any WordPress content, including output from Shortcodes and other plugin functions.
Author: David F. Carr
Version: 1.8
Author URI: http://www.carrcommunications.com/
*/

//make sure new rules will be generated for custom post type

function draw_taboptions() {

global $wpdb;
global $post;

if($_GET["post"])
{
$custom_fields = get_post_custom($post->ID);
$permalink = get_permalink($post->ID);
}
else
{
	$fbtabset = get_option('fbtabset');
	$remove_filter = get_option('fbt_remove_filter');
	if($fbtabset)
	foreach ($fbtabset as $name => $value)
		$custom_fields['_'.$name][0] = $value;
	
	if($remove_filter)
		$custom_fields["_remove_filter"] = $remove_filter;
}

fbtab_options_ui($custom_fields);

?><em>Example: If a plugin is filtering post content to add links or icons that you do not want to appear on your Facebook tab.</em></p>

<input type="hidden" name="fbtabdata" value="1"  />
<?php

if($permalink)
	{
	if(strpos($permalink,'?') )
		echo '<h1 style="color: red;">The instructions below will not work if you do not have &quot;pretty permalinks&quot; enabled.</h1><p>Visit the <a href="http://www.carrcommunications.com/wp-admin/options-permalink.php">Permalinks settings page and choose &quot;day and name&quot;, &quot;month and name&quot; or similar format.</p>';
	$pp = explode('/fbtab/',$permalink);
	$bp = explode('//',$pp[0]);

if($post->post_parent)
	{
	$canvas = get_permalink($post->post_parent);
	$tab = str_replace($canvas,'',$permalink);
	$parent = $post->post_parent;
	}
else
	{
	$child = $wpdb->get_var("SELECT ID from $wpdb->posts WHERE post_parent=$post->ID AND post_status='publish'");
	if($child)
		{
		$canvas = $permalink;
		$tab = str_replace($canvas,'',get_permalink($child));
		}
	else
		{
		$canvas = $pp[0].'/fbtab/';
		$tab = $pp[1];
		}
	}

if($parent)
	echo '<h3>Viewing Page Tab</h3><p><a href="post.php?post='.$parent.'&action=edit">Edit Canvas</a></p>';
elseif($child)
	echo '<h3>Viewing Canvas</h3><p><a href="post.php?post='.$child.'&action=edit">Edit Tab</a></p>';
else
{

?>
<h3>Create Canvas?</h3>
<p>These instructions above will let you create a stand-alone page tab. If you want to get a little fancier, you may also wish to add a canvas page that can be viewed outside of the context of a page tab. Facebook Tab Manager will let you duplicate the contents of this WordPress document, creating two posts, a tab and a canvas. This will also change the instructions for registering your app on Facebook. You can then modify the canvas post to take advantage of the greater width of a canvas page.</p>
<p><a href="<?=$_SERVER['REQUEST_URI']?>&create_canvas=1">Create tab/canvas pair.</a></p>

<?php
}
?>

<h3>To Install This as a Facebook Tab</h3>
<ol>
  <li>Visit the <a href="http://www.facebook.com/developers/" target="_blank">Facebook Developers</a> utility for app registration</li>
  <li>Click the Create New App button</li>
  <li>Fill out the registraition form, including the parameters below</li>
</ol>
<p><strong>Website Tab</strong>
  <br />
Site URL: <strong><?=$pp[0]?></strong><br />
Site Domain: <strong><?=$bp[1]?></strong></p>

<p><strong>Facebook Integration Tab</strong>
  <br />
Canvas URL: <strong><?=$canvas?></strong><br />
Tab Name: (enter a short label for the tab)<br />
Tab URL: [CANVAS URL]/<strong><?=$tab?></strong> (Enter &quot;<strong><?=$tab?></strong>&quot; in the blank - including trailing &quot;<strong>/</strong>&quot;)</p>
<p>Make sure the radio buttons are set to IFrame, not FBML, for both the Canvas URL and the Tab URL.</p>
<?php if(!$parent && !$child) { ?>
<p>Filling in the blank for Canvass Page is not really necessary if you are setting this up as a stand-alone tab, with no corresponding canvas page. However, the Canvas URL variable must be filled in, or the tab will not work.</p>
<?php } ?>
<p>After saving your work, visit the Application Profile Page Facebook creates. On the left hand side of the page, click the link that says Add to my Page. Select the page you want, and a tab with the content from Facebook Tab Manager should appear as a new tab on your page. Note: You must upgrade to the new page layout introduced in February 2011 for an IFrame tab to work correctly. More documentation at the <a href="http://www.carrcommunications.com/wordpress-plugins/facebook-tab-manager/">Facebook Tab Manager home page</a>.</p>

<p>Example Configuration:<br />
  <br />
  <img src="<?=plugins_url()?>/facebook-tab-manager/screenshot-1.png" alt="Example Configuration" width="516" height="691" /><br />
</p>
<?php
	}

}

// create custom plugin settings menu
add_action('admin_menu', 'fbtab_create_menu');

function fbtab_create_menu() {

	//create new top-level menu
	add_submenu_page('options-general.php','FB Tab Settings', 'FB Tab Settings', 'manage_options', 'fbtab_settings_page', 'fbtab_settings_page');

	//call register settings function
	add_action( 'admin_init', 'register_mysettings' );
}


function register_mysettings() {
	//register our settings
	register_setting( 'fbtab-settings-group', 'fbtabopt' );
	register_setting( 'fbtab-settings-group', 'fbt_remove_filter' );
}

function fbtab_settings_page() {
?>
<div class="wrap">
<h2>Facebook Tab Manager</h2>
<p>Set your defaults</p>
<form method="post" action="options.php">
<?php settings_fields( 'fbtab-settings-group' );
	
	$fbtabset = get_option('fbtabset');
	$remove_filter = get_option('fbt_remove_filter');
	foreach ($fbtabset as $name => $value)
		$custom_fields['_'.$name][0] = $value;
	
	if($remove_filter)
		$custom_fields["_remove_filter"] = $remove_filter;
	fbtab_options_ui($custom_fields, true);
?>
    
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>

</form>
</div>
<?php }


function fbtab_options_ui($custom_fields = NULL, $settings=false) {

if($settings)
	{
	$wrapper = "fbtabopt";
	$filteropt = 'fbt_';
	}
else
	$wrapper = "fbtabset";

?>
CSS Styles:<br /> 
<textarea name="<?=$wrapper?>[style]" cols="60" rows="5"><?=$custom_fields["_style"][0]?></textarea><br />
<a target="_blank" href="<?=plugins_url()?>/facebook-tab-manager/fbtab-css.php?show=text">See default styles</a><br />
<input type="checkbox" name="<?=$wrapper?>[new_window]" value="1" <?php if($custom_fields["_new_window"][0]) echo ' checked="checked" '; ?>  />
Open Links / Post Forms to New Window<br />
<input type="checkbox" name="<?=$wrapper?>[wp_head]" value="1" <?php if($custom_fields["_wp_head"][0]) echo ' checked="checked" '; ?>  />
Template should execute theme/plugin code in HTML head - wp_head() command<br />
<input type="checkbox" name="<?=$wrapper?>[wp_footer]" value="1" <?php if($custom_fields["_wp_footer"][0]) echo ' checked="checked" '; ?>  />
Template should execute theme/plugin code in page footer - wp_footer()<br />
<input type="checkbox" name="<?=$wrapper?>[resize]" value="1" <?php if($custom_fields["_resize"][0]) echo ' checked="checked" '; ?>  />
Set resize/autoresize (for tabs taller than 800 pixels)<br />
<p>Remove content filter:<br /><?php

global $wp_filter;
foreach($wp_filter["the_content"] as $filterarray)
	{
	foreach($filterarray as $name => $details)
		{
		if(is_array($custom_fields["_remove_filter"]) && in_array($name,$custom_fields["_remove_filter"]) )
			$c = ' checked="checked" ';
		else
			$c = '';
		echo '<input type="checkbox" name="'.$filteropt.'remove_filter[]" value="'.$name.'" '.$c.'>'.$name."<br />";
		}
	}
}

add_action( 'init', 'create_fbtab_post_type' );

//    'menu_icon' => WP_PLUGIN_URL.'/chimpblast/email.gif',

function create_fbtab_post_type() {
  register_post_type( 'fbtab',
    array(
      'labels' => array(
        'name' => __( 'Facebook Tabs' ),
        'add_new_item' => __( 'Add New Facebook Tab' ),
        'edit_item' => __( 'Edit Facebook Tab' ),
        'new_item' => __( 'Facebook Tabs' ),
        'singular_name' => __( 'Facebook Tab' )
      ),
	'public' => true,
	'exclude_from_search' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'query_var' => true,
    'rewrite' => true,
    'capability_type' => 'page',
    'hierarchical' => true,
    'menu_position' => 5,
	'menu_icon' => WP_PLUGIN_URL.'/facebook-tab-manager/facebook.png',
    'supports' => array('title','editor')
    )
  );

flush_rewrite_rules();
}

add_action("template_redirect", 'fbtab_template_redirect');

// Template selection
function fbtab_template_redirect()
{

global $wp;
global $wp_query;

	if ($wp->query_vars["post_type"] == "fbtab")
	{
		if (have_posts())
		{
			include(WP_PLUGIN_DIR . '/facebook-tab-manager/template.php');
			die();
		}
		else
		{
			$wp_query->is_404 = true;
		}

	}
}

function my_fbtab_menu() {
add_meta_box( 'fbtabbox', 'Options', 'draw_taboptions', 'fbtab', 'normal', 'high' );
}

add_action('admin_menu', 'my_fbtab_menu');

function save_fbtab_data($postID) {

if(!$_POST["fbtabdata"])
	return;
// we only care about saving fbtabdata

	global $wpdb;
	global $current_user;
	
	if($parent_id = wp_is_post_revision($postID))
		{
		$postID = $parent_id;
		}
		
		foreach($_POST["fbtabset"] as $name => $value)
			{
			$field = '_'.$name;
			$single = true;
			$current = get_post_meta($postID, $field, $single);
			 
			if($value && ($current == "") )
				add_post_meta($postID, $field, $value, true);
			
			elseif($value != $current)
				update_post_meta($postID, $field, $value);
			
			elseif($value == "")
				delete_post_meta($postID, $field, $current);
			}
	if($_POST["remove_filter"])
	{
	$field = '_remove_filter';
	$single = false;
	$current = get_post_meta($postID, $field, $single);
	
	if(is_array($current) )
		{
		$delete = array_diff($current, $_POST["remove_filter"]);
		if(is_array($delete))
			foreach($delete as $d)
				delete_post_meta($postID, $field, $d);
		}
	

	foreach($_POST["remove_filter"] as $value)
		{

			if(is_array($current) && (!in_array($value,$current)) )
				{
				add_post_meta($postID, $field, $value, $single);
				}
		}
	}
}

add_action('save_post','save_fbtab_data');

add_filter('mce_css', 'fbtab_mce_css');
function fbtab_mce_css($style) {
global $post;
if(($post->post_type == 'fbtab') || ($_GET["post_type"] == 'fbtab'))
  return plugins_url().'/facebook-tab-manager/fbtab-css.php?postid='.$post->ID;
 else
 	return $style;
}

function fbtab_shortcode($atts = NULL, $content = NULL ) {

if($atts["query"])
	{
	ob_start();
	query_posts($atts["query"]);

if ( have_posts() ) {
while ( have_posts() ) : the_post(); ?>
<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
<h1 class="entry-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h1>
<?php
if($atts["format"] == 'headline')
	;
elseif($atts["format"] == 'excerpt')
	{
?>
<div class="excerpt-content">

<?php the_excerpt(); ?>

</div><!-- .excerpt-content -->
<?php	
	}
else
	{
?>
<div class="entry-content">

<?php the_content(); ?>

</div><!-- .entry-content -->
<?php
}
?>
</div>
<?php 
endwhile;
?>
<p><?php posts_nav_link(' &#8212; ', __('&laquo; Previous Page'), __('Next Page &raquo;')); ?></p>
<?php
} 
	
	$content = ob_get_clean();
	}
elseif($content)
	{
	//check for numeric references, variants on quotation marks entities
	$content = preg_replace('/&(#8220|#8221|#8243|quot|ldquo|rdquo);/','"',$content);
	$content = preg_replace('/&(#8216|#8217|apos|lsquo|rsquo);/',"'",$content);
	//convert standard entities including <>
	$content = html_entity_decode($content);
	$content = '<div style="margin-top: 10px; margin-bottom: 10px;">'.$content.'</div>';
	}

	return $content;
}
add_shortcode('fbtab', 'fbtab_shortcode');

function create_canvas() {
if(!$_GET["create_canvas"])
	return;
// if this is a create canvas call, continue
$up = explode('&create_canvas',$_SERVER['REQUEST_URI']);
$redirect = "Location: ".$up[0];
$postid = (int) $_GET["post"];
$canvas = get_post($postid);

if($canvas->post_type != 'fbtab')
	return;

$tabarray = array(
'post_status' => 'publish', 
'post_type' => 'fbtab',
'post_author' => $canvas->post_author,
'post_parent' => $postid,
'post_title' => 'Tab: '.$canvas->post_title,
'post_content' => $canvas->post_content,
'post_name' => 'tab'.$postid
);
$tabid = wp_insert_post( $tabarray );

$custom = get_post_custom($postid);
if($custom)
foreach ($custom as $field => $value)
	{
	if($field == '_remove_filter')
		{
		foreach($value as $v)
			{
			add_post_meta($tabid, $field, $v, false);
			}
		}
	else
		add_post_meta($tabid, $field, $value[0], true);
	}

header($redirect);
exit();

}

add_action('admin_init','create_canvas');

?>